<ui:composition template="/WEB-INF/templates/layout.xhtml"
	xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:h="http://xmlns.jcp.org/jsf/html"
	xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	xmlns:p="http://primefaces.org/ui">
	
	<ui:param name="title" value="Create Task" />
	
	<ui:define name="content">
		<div class="content-wrapper">
			<div class="content-header">
				<h1>Create task</h1>
				<h5>You can create a new task here.</h5>
			</div>
			<p:separator />
			<div class="content-body p-formgrid ui-fluid">
				<div class="card">
					<h:form id="newTaskForm">
						<p:messages id="messages" globalOnly="true" showDetail="true">
							<p:autoUpdate />
						</p:messages>
						<div class="form-element p-field">
							<p:outputLabel for="taskName" value="Name" />
							<p:inputText id="taskName" value="#{taskBacking.name}"
								required="true" 
								requiredMessage="Task name cannot be empty">
								<p:clientValidator event="blur" />
								<p:ajax event="blur" listener="#{taskBacking.onNameChange}" update="taskName-error" />	
							</p:inputText>
							<small><p:message id="taskName-error" for="taskName" display="text" /></small>
						</div>
						<div class="form-element p-field">
							<p:outputLabel for="startDate" value="Start date" />
							<p:datePicker id="startDate" value="#{taskBacking.startDate}"
								required="true"
								requiredMessage="Start date cannot be empty"
								showOtherMonths="true"
								selectOtherMonths="false"
								monthNavigator="true"
								yearNavigator="true"
								placeholder="e.g. 10/30/2019"
								pattern="MM/dd/yyyy">
								<p:clientValidator />
								<f:convertDateTime pattern="MM/dd/yyyy" type="localDate" />
								<p:ajax event="dateSelect" listener="#{taskBacking.onStartDateSelect}" update="startDate-error" />
							</p:datePicker>
							<small><p:message id="startDate-error" for="startDate" display="text" /></small>
						</div>
						<div class="form-element p-field">
							<p:outputLabel for="dueDate" value="Due date (expected)" />
							<p:datePicker id="dueDate" value="#{taskBacking.dueDate}"
								required="true"
								requiredMessage="Due date cannot be empty"
								showOtherMonths="true"
								selectOtherMonths="false"
								monthNavigator="true"
								yearNavigator="true"
								placeholder="e.g. 10/30/2019"
								pattern="MM/dd/yyyy">
								<p:clientValidator />
								<f:convertDateTime pattern="MM/dd/yyyy" type="localDate" />
								<p:ajax event="dateSelect" listener="#{taskBacking.onDueDateSelect}" update="dueDate-error" />
							</p:datePicker>
							<small><p:message id="dueDate-error" for="dueDate" display="text" /></small>
						</div>
						<div class="project form-element p-field">
							<p:outputLabel for="project" value="Project" />
							<p:selectOneMenu id="project" value="#{taskBacking.projectId}">
								<f:selectItem itemLabel="Select a project" itemValue="0" noSelectionOption="true" />
								<f:selectItems value="#{taskBacking.projects}"
									var="project"
									itemLabel="#{project.name}"
									itemValue="#{project.id}" />
							</p:selectOneMenu>
						</div>
						<div class="form-element p-field">
							<p:outputLabel for="status" value="Status" />
							<p:selectOneMenu id="status" value="#{taskBacking.statusId}">
								<f:selectItem itemLabel="Select a status" itemValue="0" noSelectionOption="true" />
								<f:selectItems value="#{taskBacking.statuses}"
									var="status"
									itemLabel="#{status.name}"
									itemValue="#{status.id}" />
							</p:selectOneMenu>
						</div>
						<div class="form-element p-field">
							<p:outputLabel for="taskPriority" value="Priority" />
							<p:selectOneMenu id="taskPriority" value="#{taskBacking.priorityId}" effect="none">
								<f:selectItem itemLabel="Select a priority level" itemValue="0" noSelectionOption="true" />
								<f:selectItems value="#{taskBacking.priorities}"
								 	var="priority"
								 	itemLabel="#{priority.name}"
								 	itemValue="#{priority.id}" />
							</p:selectOneMenu>
							<div class="btn-add">
								<p:commandButton id="btnNewPriority" 
									value="New priority"
									oncomplete="PF('newPriorityDialog').show()" />
							</div>
						</div>
						<div class="form-element p-field">
							<p:outputLabel for="taskAssignee" value="Assignee" />
							<p:selectOneMenu id="taskAssignee" value="#{taskBacking.assigneeId}">
								<f:selectItem itemLabel="Assign someone to the task" itemValue="0" noSelectionOption="true" />
								<f:selectItems value="#{taskBacking.assignees}"
									var="assignee" 
									itemLabel="#{assignee.firstName} #{assignee.lastName}"
									itemValue="#{assignee.id}" />
							</p:selectOneMenu>
						</div>
						<div class="btn-container">
							<p:commandButton id="btnCreateTask" 
								value="Save"
								action="#{taskBacking.createNewTask()}"  
								validateClient="true" 
								update="@form" 
								styleClass="form-button" />
							<p:linkButton outcome="/user/dashboard" value="Cancel" styleClass="form-button btn-delete" />
						</div>
					</h:form>
				</div>
				
				<p:dialog id="newPriorityDialog" widgetVar="newPriorityDialog" header="New task priority" modal="true">
					<h:form id="newPriority">
						<p:panelGrid columns="3">
							<p:outputLabel for="priorityName" value="New task priority name: " />
							<p:inputText id="priorityName" value="#{taskBacking.newPriorityName}" />
						</p:panelGrid>
						<div class="btn-container">
							<div class="ui-g-6">
								<p:commandButton id="btnCreatePriority" value="Create" 
									action="#{taskBacking.createNewPriority()}" 
									oncomplete="PF('newPriorityDialog').hide()"
									update="newTaskForm:taskPriority" />
							</div>
							<div class="ui-g-6">
								<p:commandButton id="btnCancelCreatePriority" value="Cancel" onclick="PF('newPriorityDialog').hide()" />
							</div>
						</div>
					</h:form>
				</p:dialog>
					
			</div>
		</div>
	</ui:define>
</ui:composition>